package com.benyun.core.controller;

import com.benyun.core.constant.RedisContant;
import com.benyun.core.entity.TopologicalStoreWd;
import com.benyun.core.entity.bo.StoreWdCategoryCountBody;
import com.benyun.core.entity.bo.WdCount;
import com.benyun.core.entity.vo.TopologicalWdAceeptVo;
import com.benyun.core.service.TopologicalStoreWdService;
import com.benyun.core.valida.TopologicalWdGroup;
import com.benyun.core.valida.TopologicalWdListGroup;
import com.github.pagehelper.PageInfo;
import com.ruoyi.common.core.domain.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.concurrent.TimeUnit;

@RestController
@RequestMapping("/poi/topologicalStoreWd")
public class TopologicalStoreWdController {

    @Autowired
    TopologicalStoreWdService topologicalStoreWdService;

    @Autowired
    RedisTemplate redisTemplate;

    @RequestMapping("/category")
    public R category(@Validated(value = {TopologicalWdGroup.class}) TopologicalWdAceeptVo topologicalWdAceeptVo){
        String md5 = topologicalWdAceeptVo.getHash();
        //2.查看redis中是否存在有缓存
        List<StoreWdCategoryCountBody> wdCount = (List<StoreWdCategoryCountBody>) redisTemplate.boundHashOps(RedisContant.TOPOLOGICAL_STORE_WD_CATEGORY).get(md5);
        if (wdCount != null) {
            return R.ok(wdCount);
        }

        List<StoreWdCategoryCountBody> category = topologicalStoreWdService.category(topologicalWdAceeptVo);

        redisTemplate.boundHashOps(RedisContant.TOPOLOGICAL_STORE_WD_CATEGORY).put(md5,category);
        redisTemplate.expire(RedisContant.TOPOLOGICAL_STORE_WD_CATEGORY,RedisContant.TOPOLOGICAL_STORE_WD_CATEGORY_TIME, TimeUnit.MINUTES); //30分钟

        return R.ok(category);
    }

    @RequestMapping("/list")
    public R list(@Validated(value = {TopologicalWdListGroup.class}) TopologicalWdAceeptVo topologicalWdAceeptVo){
        String md5 = topologicalWdAceeptVo.getHash();
        //2.查看redis中是否存在有缓存
        PageInfo<TopologicalStoreWd> wdCount = (PageInfo<TopologicalStoreWd>) redisTemplate.boundHashOps(RedisContant.TOPOLOGICAL_STORE_WD_LIST).get(md5);
        if (wdCount != null) {
            return R.ok(wdCount);
        }


        PageInfo<TopologicalStoreWd> list = topologicalStoreWdService.list(topologicalWdAceeptVo);

        redisTemplate.boundHashOps(RedisContant.TOPOLOGICAL_STORE_WD_LIST).put(md5,list);
        redisTemplate.expire(RedisContant.TOPOLOGICAL_STORE_WD_LIST,RedisContant.TOPOLOGICAL_STORE_WD_LIST_TIME, TimeUnit.MINUTES); //30分钟

        return R.ok(list);
    }
}
