package com.benyun.core.entity.vo;

import com.benyun.core.utils.HashUtil;
import com.benyun.core.valida.TopologicalWdGroup;
import com.benyun.core.valida.TopologicalWdListGroup;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

@Data
public class TopologicalWdAceeptVo {

    @NotBlank(groups = {TopologicalWdGroup.class,TopologicalWdListGroup.class},message = "请选择中心点")
    String centerWdId;
    @NotNull(groups = {TopologicalWdGroup.class,TopologicalWdListGroup.class},message = "半径范围未正确选择")
    int radius;
    int pageNum = 1;
    int pageSize = 10;

    public String getHash(){
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(centerWdId);
        stringBuilder.append(radius);
        stringBuilder.append(pageNum);
        stringBuilder.append(pageSize);

        String s = stringBuilder.toString();
        String md5 = HashUtil.hash(s, "MD5");
        return md5;
    }
}
