package com.benyun.core.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.benyun.core.dao.TopologicalStoreWdDao;
import com.benyun.core.dao.TopologicalStoreWdStatisticsCategoryDao;
import com.benyun.core.entity.TopologicalStoreWd;
import com.benyun.core.entity.TopologicalStoreWdStatisticsCategory;
import com.benyun.core.entity.WdInfo;
import com.benyun.core.entity.bo.StoreWdCategoryCount;
import com.benyun.core.entity.bo.StoreWdCategoryCountBody;
import com.benyun.core.entity.vo.TopologicalWdAceeptVo;
import com.benyun.core.service.TopologicalStoreWdService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

@Service
public class TopologicalStoreWdServiceImpl implements TopologicalStoreWdService {

    @Autowired
    TopologicalStoreWdDao topologicalStoreWdDao;

    @Autowired
    TopologicalStoreWdStatisticsCategoryDao storeWdStatisticsCategoryDao;

    @Autowired
    @Qualifier("ManageType")
    HashMap<String,String> manageType;

    @Override
    public PageInfo<TopologicalStoreWd> list(TopologicalWdAceeptVo topologicalWdAceeptVo) {
        PageHelper.startPage(topologicalWdAceeptVo.getPageNum(), topologicalWdAceeptVo.getPageSize());
        List<TopologicalStoreWd> topologicalStoreWds = topologicalStoreWdDao.list(topologicalWdAceeptVo.getCenterWdId(), Integer.valueOf(topologicalWdAceeptVo.getRadius()));
        PageInfo<TopologicalStoreWd> pageInfo = new PageInfo<>(topologicalStoreWds);
        return pageInfo;
    }

    //TODO 需要优化
    @Override
    public List<StoreWdCategoryCountBody> category(TopologicalWdAceeptVo topologicalWdAceeptVo) {

        List<StoreWdCategoryCountBody> storeWdCategoryCountBodyList = new ArrayList<>();
        List<StoreWdCategoryCount> storeWdCategoryCounts = new ArrayList<>();

        int index1 = 0;
        List<TopologicalStoreWdStatisticsCategory> statisticsCategories = storeWdStatisticsCategoryDao.category(topologicalWdAceeptVo.getCenterWdId(),Integer.valueOf(topologicalWdAceeptVo.getRadius()));
        for (TopologicalStoreWdStatisticsCategory statisticsCategory : statisticsCategories) {
            StoreWdCategoryCountBody storeWdCategoryCountBody = new StoreWdCategoryCountBody();
            storeWdCategoryCountBody.setName(manageType.get(statisticsCategory.getMidManageTypeCode()));
            storeWdCategoryCountBody.setManage_type_code(statisticsCategory.getMidManageTypeCode());

            //拆分
            int index2 = 0;
            String subCategoryCodeStatistics = statisticsCategory.getSubCategoryCodeStatistics();
            for (String s : subCategoryCodeStatistics.split(";")) {
                StoreWdCategoryCount storeWdCategoryCount = new StoreWdCategoryCount();
                String[] split = s.split(":");
                if (split.length !=2)
                    continue;
                storeWdCategoryCount.setName(manageType.get(split[0]));
                storeWdCategoryCount.setCount(Integer.parseInt(split[1]));
                index2+=storeWdCategoryCount.getCount();
                storeWdCategoryCounts.add(storeWdCategoryCount);
            }
            storeWdCategoryCountBody.setCount(index2);

            //计算radio
            for (StoreWdCategoryCount storeWdCategoryCount : storeWdCategoryCounts) {
                storeWdCategoryCount.setRadio(storeWdCategoryCount.getCount()/index2);
            }

            index1+=index2;
            storeWdCategoryCountBodyList.add(storeWdCategoryCountBody);
        }

        //计算radio
        for (StoreWdCategoryCountBody storeWdCategoryCountBody : storeWdCategoryCountBodyList) {
            storeWdCategoryCountBody.setRadio(storeWdCategoryCountBody.getCount()/index1);
        }

        return storeWdCategoryCountBodyList;
    }
}
